package java_sound_complete;

import javax.sound.sampled.*;
import java.io.*;

class SoundFileAbspielen extends Thread {
    
    static File file;
    static AudioInputStream stream = null;
    static SourceDataLine sourceLine_1 = null;
    static byte[] ba = null;
    static int AnzahlGelBytes = 0;
    static FloatControl gainControl;
    
    public SoundFileAbspielen() {
        
        //InputStream erzeugen fr Quelldatei erzeugen
        InputStream in=this.getClass().getResourceAsStream("tos.wav");
        
        try {
            //AudioStream holen
            stream = AudioSystem.getAudioInputStream(in);
        } catch (Exception e) {
            System.out.println("SoundFileAbspielen: Fehler bei Erzeugung des Streams");
            System.exit(1);
        }
        
        //Info-Objekt fr SRC-DataLine zum Abspielen erzeugen, Format des Streams bergeben
        DataLine.Info info = new DataLine.Info(SourceDataLine.class, stream.getFormat());
        
        
        try {
            //Src-Data-Line erzeugen
            sourceLine_1 = (SourceDataLine) AudioSystem.getLine(info);
        } catch (LineUnavailableException e) {
            System.out.println("SoundFileAbspielen: Fehler bei Line bekommen");
            System.exit(1);
        }
    } // ENDE KONSTRUKTOR
    
    public void run() {
        //ffne SourceDataLine zum Abspielen
        try {
            sourceLine_1.open();
        } catch (LineUnavailableException e) {
            System.out.println("SoundFileAbspielen: Fehler bei ffnen der Line ");
            System.exit(1);
        }
        // MACHT DAS ABSPIELEN LAUTER
        if (sourceLine_1.isControlSupported(FloatControl.Type.MASTER_GAIN)) {
            gainControl = (FloatControl) sourceLine_1.getControl(FloatControl.Type.MASTER_GAIN);
            //Gain auf 6 setzen
            if (gainControl != null) gainControl.setValue(6.0f);
        }
        
        // Line starten
        sourceLine_1.start();
        
        //Buffer anlegen, in den Sounddatei eingelesen wird
        ba = new byte[1024];
        
        // while-Schleife zum Abspielen des Sounds
        while (true) {
            //Sound in Buffer einlesen
            try {
                AnzahlGelBytes = stream.read(ba, 0, 1024);
            } catch (IOException e) {
                System.out.println("SoundFileAbspielen: Fehler beim Auslesen des Streams");
                System.exit(1);
            }
            //wenn Ende von SoundFile, dann wird die Schleife abgebrochen
            if (AnzahlGelBytes == -1)
                break;
            //Gelesene Daten werden in sourceLine_1 geschrieben, damit sie abgespielt werden knne
            sourceLine_1.write(ba, 0, ba.length);
        }
        sourceLine_1.drain(); //sourceLine leeren
        sourceLine_1.stop();
        sourceLine_1.close();
        sourceLine_1 = null;
        
    }
    
}
